> ## Documentation Index
> Fetch the complete documentation index at: https://docs.firedrill.run/llms.txt
> Use this file to discover all available pages before exploring further.

# Browse verified bundled Tool packages before creating source



## OpenAPI

````yaml /api-reference/openapi.json get /v1/projects/{projectId}/tool-library
openapi: 3.1.0
info:
  title: Firedrill Control API
  version: 1.0.0
  description: >-
    The control plane for drills, drill runs, and the worlds they run in. Errors
    always carry the canonical envelope; unsafe operations require an
    Idempotency-Key; long work returns an operation resource.
servers:
  - url: https://api.firedrill.run
security:
  - controlCredential: []
paths:
  /v1/projects/{projectId}/tool-library:
    get:
      summary: Browse verified bundled Tool packages before creating source
      operationId: toolLibrary.list
      parameters:
        - name: projectId
          in: path
          required: true
          schema:
            type: string
            pattern: ^prj_[0-9a-z]{12,32}$
        - name: cursor
          in: query
          schema:
            type: string
            maxLength: 2048
        - name: limit
          in: query
          schema:
            type: integer
            minimum: 1
            maximum: 50
            default: 25
        - name: q
          in: query
          schema:
            type: string
            maxLength: 100
      responses:
        '200':
          description: Reviewed Tool library page
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ToolLibraryPage'
        default:
          description: Canonical error envelope
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorEnvelope'
components:
  schemas:
    ToolLibraryPage:
      type: object
      properties:
        items:
          maxItems: 50
          type: array
          items:
            type: object
            properties:
              libraryEntryId:
                type: string
                pattern: ^[a-z0-9][a-z0-9-]{0,79}$
              title:
                type: string
                minLength: 1
                maxLength: 160
              packageName:
                type: string
                minLength: 1
                maxLength: 214
              packageVersion:
                type: string
                minLength: 1
                maxLength: 100
              packageArchiveDigest:
                type: string
                pattern: ^sha256:[0-9a-f]{64}$
              packageId:
                type: string
                minLength: 1
                maxLength: 255
              manifestHash:
                type: string
                pattern: ^sha256:[0-9a-f]{64}$
              description:
                type: string
                maxLength: 4000
              manifest:
                type: object
                additionalProperties:
                  $ref: '#/components/schemas/ToolLibraryPage___schema0'
              ui:
                type: object
                additionalProperties:
                  $ref: '#/components/schemas/ToolLibraryPage___schema0'
              starter:
                type: object
                properties:
                  available:
                    type: boolean
                  rows:
                    type: integer
                    minimum: 0
                    maximum: 9007199254740991
                  virtualTimeUs:
                    type: integer
                    minimum: 0
                    maximum: 9007199254740991
                required:
                  - available
                  - rows
                  - virtualTimeUs
                additionalProperties: false
              files:
                maxItems: 2000
                type: array
                items:
                  type: object
                  properties:
                    path:
                      type: string
                      minLength: 1
                      maxLength: 512
                    digest:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    bytes:
                      type: integer
                      minimum: 0
                      maximum: 8388608
                  required:
                    - path
                    - digest
                    - bytes
                  additionalProperties: false
            required:
              - libraryEntryId
              - title
              - packageName
              - packageVersion
              - packageArchiveDigest
              - packageId
              - manifestHash
              - description
              - manifest
              - starter
              - files
            additionalProperties: false
        nextCursor:
          type: string
          maxLength: 2048
      required:
        - items
      additionalProperties: false
    ErrorEnvelope:
      type: object
      properties:
        code:
          type: string
          pattern: ^(control|world)\.[A-Z][A-Z0-9]*(_[A-Z0-9]+)*$
        message:
          type: string
          minLength: 1
        correlationId:
          type: string
          minLength: 1
        retryable:
          type: boolean
        retryAfterMs:
          type: integer
          exclusiveMinimum: 0
          maximum: 9007199254740991
        operationId:
          type: string
        source:
          type: string
          enum:
            - platform
            - simulated_provider
        issues:
          type: array
          items:
            type: object
            properties:
              path:
                type: string
              code:
                type: string
              message:
                type: string
            required:
              - path
              - code
              - message
            additionalProperties: false
        details:
          type: object
          propertyNames:
            type: string
          additionalProperties: {}
        evidence:
          type: object
          properties:
            sessionId:
              type: string
            runId:
              type: string
            journalSeq:
              type: integer
              minimum: 0
              maximum: 9007199254740991
            buildHash:
              type: string
          additionalProperties: false
      required:
        - code
        - message
        - correlationId
        - retryable
        - source
      additionalProperties: true
    ToolLibraryPage___schema0:
      description: Any JSON-compatible value
  securitySchemes:
    controlCredential:
      type: http
      scheme: bearer
      description: Opaque control credential

````